<?php
/*
 * index.php
 * ------------------------------------------------------------
 * Type:      PHP/MySQL
 * Name:      MyGosuClan
 * Version:   1.04
 * License:   GNU GPL
 * Author:    cagrET (Cezary Tomczak)
 * Homepage:  http://www.gosu.pl/mgc/
 * E-mail:    cagret at gmail.com
 * ------------------------------------------------------------
 */

include 'init/initialize.php';
ob_start();

switch($sub) {

  # -------------
  # admin classes
  # -------------

  case '_news':
      if($access['news']) {
          include 'modules/news/inc.NewsAdmin.php';
          new _news($db,$smarty);
      }
      else $smarty->display('default.tpl');
      break;
      
  case '_users':
      if($access['users']) {
          include 'modules/users/inc.UsersAdmin.php';
          new _users($db,$smarty, $cfg['users_admin']);
      }
      else $smarty->display('default.tpl');
      break;
      
  case '_members':
      if($access['members']) {
          include 'modules/members/inc.MembersAdmin.php';
          new _members($db,$smarty);
      }
      else $smarty->display('default.tpl');
      break;
      
  case '_profile':
      if($_SESSION['mgc']['auth'] >= $auth['member']) {
          include 'modules/members/inc.ProfileAdmin.php';
          new _profile($db,$smarty);
      }
      else $smarty->display('default.tpl');
      break;
      
  case '_banip':
      if($access['ipban']) {
          include 'modules/ipban/inc.IPban.php';
          new _banip($db,$smarty);
      }
      else $smarty->display('default.tpl');
      break;
      
  case 'ftp':
      if($GLOBALS['access']['ftp']) {
          include 'modules/ftp/inc.Ftp.php';
          new ftp($smarty,$cfg['ftp_dir'],$cfg['ftp_size'],$cfg['ftp_ext_na']);
      }
      else $smarty->display('default.tpl');
      break;

  case 'clanwars':
    if($access['clanwars'])
    {
      include 'modules/clanwars/inc.ClanwarsAdmin.php';
      include 'init/lib/files.lib.php';
      $cw = new clanwars_admin;
      $cw->db = &$db;
      $cw->smarty = &$smarty;
      $cw->prefix = $cfg['prefix'];
      $cw->show = $cfg['clanwars_admin'];
      $cw->flags_dir = $cfg['flags_dir'];
      $cw->tpl_dir = 'admin/clanwars/';
      $cw->init();
    }
  break;
  
  case 'replays':
      if($GLOBALS['access']['replays']) {
          include 'modules/replays/admin_replays.php';
      }
      else $smarty->display('default.tpl');
      break;
      
  case 'calendar':
      if ($access['calendar']) {
          include_once 'modules/calendar/inc.Calendar.php';
          $cal = new Calendar($db, $cfg['prefix']);
          
          if (isset($_POST['calendar'])) {
              $cal->update_calendar($_POST['calendar']);
          }
          $smarty->assign('calendar', $cal->get_calendar(true));
          $smarty->display('calendar/admin/calendar.tpl');
      }
      else $smarty->display('default.tpl');
      break;

  default: $smarty->display('default.tpl');
  
}

if (error_reporting() == -1) {
	echo '<div style="text-align: center;">error_reporting = -1</div>';
}

?>
