<?php
/**
* init.error.php
* ------------------------------------------------------------
* Package:   MyGosuClan
* Version:   1.04
* License:   GNU GPL
* Author:    cagrET (Cezary Tomczak)
* Email:     cagret at gmail.com
* Homepage:  http://www.gosu.pl/mgc/
* ------------------------------------------------------------
*/

define('LOCALHOST', ('127.0.0.1' == $_SERVER['REMOTE_ADDR'] && '127.0.0.1' == $_SERVER['SERVER_ADDR']));

if (LOCALHOST || stristr($_SERVER['SERVER_NAME'], 'mgcdev.yoyo.pl')) {
	error_reporting(-1); // all errors, including: strict, deprecated etc.
} else {
	error_reporting(E_ALL);
}
ini_set('display_errors', 1);
ini_set('log_errors', 1);
ini_set('error_log', '!phperror.log');
ini_set('html_errors', 0);
ini_set('date.timezone', 'Europe/Warsaw');
ini_set('zend.ze1_compatibility_mode', 0);

set_error_handler('error_handler');
if (function_exists('error_get_last')) {
	register_shutdown_function('error_handler_fatal');
	ini_set('display_errors', 0);
}

header('X-Powered-By: MygosuClan/1.04');

check_chmods();

function check_chmods()
{
	$writable = array(
		'_private/sessiondata',
		'_private/templates_c',
		'init',
		'uploads/ftp',
		'uploads/members',
		'uploads/replays',
	);
	$dir = realpath(dirname(__FILE__).'/../');
	foreach ($writable as $relpath) {
		$path = $dir.'/'.$relpath;
		if (!is_writable($path)) {
			if (is_file($path)) {
				$err = sprintf('File "<b>%s</b>" is not writable, you need to set write permissions on that file.', $relpath);
			} else {
				$err = sprintf('Directory "<b>%s/</b>" is not writable, you need to set write permissions on that directory.', $relpath);
			}
			trigger_error($err, E_USER_ERROR);
		}
	}
}
function error_handler_fatal()
{
	$error = error_get_last(); // php 5.2.0
	if ($error) {
		error_handler($error['type'], $error['message'], $error['file'], $error['line']);
	}
}
function error_handler($errno, $errmsg, $file, $line)
{
    if (!($errno & error_reporting())) {
        return;
    }
	
	if (!headers_sent()) {
		while (ob_get_level()) {
			ob_end_clean();
		}
		header('HTTP/1.0 503 Service Unavailable');
		header('Content-encoding: none', true);
		header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
		header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
		header("Cache-Control: no-store, no-cache, must-revalidate");
		header("Cache-Control: post-check=0, pre-check=0", false);
		header("Pragma: no-cache");		
	}

	$file = str_replace('\\', '/', $file);
	$root = $_SERVER['DOCUMENT_ROOT'];
	$root = str_replace('\\', '/', $root);
	$file = preg_replace('#^(\w+)(.*)$#ise', 'strtolower(\'\\1\').\'\\2\'', $file);
	$root = preg_replace('#^(\w+)(.*)$#ise', 'strtolower(\'\\1\').\'\\2\'', $root);
	$file = str_replace($root, '', $file);

	$errlog = sprintf('%s<br> in %s/<b>%s</b> on line <b>%s</b>', $errmsg, dirname($file), basename($file), $line);

	print '<h1>PHP error</h1>';
	print $errlog;

	if (!LOCALHOST) {
		error_log(strip_tags($errlog).'. URI: '.$_SERVER['REQUEST_URI']);
	}

    exit();
}

?>
