<?php
/*****************
 * files.lib.php *
 *****************/

# Copyright:
#
# You may use freely this script, class or functions.
# I hope you'll respect the author's intellectual property by
# --- keeping this notice in your source
# --- setting a link to the author of these PHP scripts:
# --- dropping a note to the author:
#
# Author:    cagrET <cagret at gmail.com>
# Homepage:  http://www.gosu.pl/mgc/


function natSize($number)
{
  $base = 1024;
  $suffixes = array(" B", " KB", " MB", " GB", " TB", " PB", " EB" );

  $usesuf = 0;
  $n = (float) $number; //Appears to be necessary to avoid rounding
  while( $n >= $base )
  {
    $n /= (float) $base;
    $usesuf++;
  }

  $places = 2 - floor( log10( $n ) );
  $places = max( $places, 0 );
  $retval = number_format( $n, $places, ".", "" ) . $suffixes[$usesuf];
  return $retval;

} //end func

function ReadDirectory($dir)
{
  $files = array();
  $handle = opendir($dir);
  if($handle)
  {
    while (false !== ($file = readdir($handle)))
    {
      if ($file != "." && $file != "..")
      {
        $files[] = $file;
      }
    }
    closedir($handle);
  }
  return $files;
} //end func


function ReadFromFile($filename, &$text, $trim = 'yes')
/* czytanie z pliku - referencja do zmiennej $text */
# @param $filename, $text
# @return &$text
{
  $fp = fopen($filename, 'r');
  if($fp)
  {
    flock($fp, 1);
    $text = fread($fp, filesize($filename));
    if($trim == 'yes') $text = trim($text);
    flock($fp, 3);
    fclose($fp);
  }
} //end func


function WriteToFile($filename, $text, $chmod = 0644, $trim = 'yes')
# @param $filename, $text, $chmod
# @return NULL
{
  if(file_exists($filename)) $file_exists = true;
  else $file_exists = false;
  
  $fp = fopen($filename, 'w');
  if($fp)
  {
    if(!$file_exists) chmod($filename, $chmod);
    //must clear cache - if u read the file after writing to it, the filesize is wrong !
    clearstatcache();

    flock($fp, 2);
    if($trim == 'yes')
      fwrite($fp, trim($text));
    else
      fwrite($fp, $text);
    flock($fp, 3);
    
    fclose($fp);
  }
} //end func

?>
