<?php
/*******************
 * session.lib.php *
 *******************/
 
# Copyright:
#
# You may use freely this script, class or functions.
# I hope you'll respect the author's intellectual property by
# --- keeping this notice in your source
# --- setting a link to the author of these PHP scripts:
# --- dropping a note to the author:
#
# Author:    cagrET <cagret at gmail.com>
# Homepage:  http://www.gosu.pl/mgc/

#
# zeby trzymac sesje we wlasnym katalogu mozna skorzystac z tych funkcji
#
# 1. tworzysz katalog "$dir" (chmod 700) oraz plik 'index.html' w nim
# 2. przed session_start wpisujesz: "session_save_path('$dir')"
# 3. po session_start,session_register wpisujesz: "CleanSessiondata('$dir', '$life')"
# ($life - w sekundach jak stara musi byc sesja aby ja usunac, default w php: 1440)
# (szansa na zbieranie smieci pzrez funkcje to 1% - tak jak default w php)
#
 
function make_seed()
{
  list($usec,$sec) = explode(" ", microtime());
  return ((float)$sec+(float)$usec) * 100000;
} //end func


function CleanSessiondata($dir, $life='1440')
{
  /* szansa na zbieranie smieci 1% */
  srand(make_seed());
  $liczba = rand(1,100);
  if(!(1 == $liczba)) return 0;

  $expire = time() - $life;

  $handle = opendir($dir);
  while (false !== ($file = readdir($handle)))
  {
    if ($file != "." && $file != ".." && $file != "index.html")
    {
      if(filectime($dir.$file) < ($expire))
      {
        @unlink($dir.$file);
      }
    }
  }
  closedir($handle);

} //end func

?>
