<?php
/****************
 * time.lib.php *
 ****************/

# Copyright:
#
# You may use freely this script, class or functions.
# I hope you'll respect the author's intellectual property by
# --- keeping this notice in your source
# --- setting a link to the author of these PHP scripts:
# --- dropping a note to the author:
#
# Author:    cagrET <cagret at gmail.com>
# Homepage:  http://www.gosu.pl/mgc/


function get_microtime()
{
  $mtime = microtime();
  $mtime = explode(" ", $mtime);
  $mtime = (double)($mtime[1]) + (double)($mtime[0]);
  return $mtime;
}

function TimeToDate($time)
# @param UNIX_TIMESTAMP
# @return date-format: yyyy-mm-dd hh:mm:ss
{
  return date('Y-m-d H:i:s', $time);
} //end func


function DateToTime($date)
{
  return strtotime($date);
} //end func


function ShortDate($date='')
/* jezeli wczesniejsze wywolanie funkcji mialo takie same parametry yyyy-mm-dd zwraca hh:mm
   jezeli yyyy-mm-dd sie zmienilo od wczesniejszego wywolania funkcji zwraca yyyy-mm-dd hh:mm
   funkcje mozna wyzerowac nie podajac parametr funkcji
   (do stosowania np na forum - data ostatniego postu)
*/
# @param $date (format: yyyy-mm-dd hh:mm:ss)
# @return 'yyyy-mm-dd hh:mm' or 'hh:mm'
{
  static $temp;

  if(!$date)
  {
    $temp = ''; return '';
  }
  elseif($temp == substr($date,0,10))
  {
    return substr($date,10,6);
  }
  else
  {
    $temp = substr($date,0,10);
    return substr($date,0,16);
  }
} //end func


function is_date($date)
/* sprawdza poprawnosc daty -> yyyy-mm-dd hh:mm:ss */
# @param $date
# @return TRUE, FALSE
{
  return preg_match("#^[0-9]{4,4}-[0-9]{2,2}-[0-9]{2,2} [0-9]{2,2}:[0-9]{2,2}:[0-9]{2,2}$#", $date);
} //end func


function Finger($time)
/* oblicza ile uplynelo dni,godzin,minut,sekund od podanego czasu - $time */
# @param $time - UNIX timestamp
# @return array('d', 'h', 'm', 's')
{
   $second = 1;   $minute = 60 * $second;   $hour =  60 * $minute;   $day = 24 * $hour;
   /* 1 */        /* 60 */                  /* 3600 */               /* 86400 */
   $ctime = time();
   $finger['d'] = floor( ($ctime-($time))/$day );
   $finger['h'] = floor( (($ctime-($time))-$finger['d']*$day)/$hour );
   $finger['m'] = floor( (($ctime-($time))-$finger['h']*$hour-$finger['d']*$day )/$minute );
   $finger['s'] = (($ctime-($time))-$finger['m']*$minute-$finger['h']*$hour-$finger['d']*$day);
   return $finger;
} //end func

?>
