<?php
/*
 * clanwars.class.php
 * ------------------------------------------------------------
 * Type:      PHP/MySQL
 * Name:      MyGosuClan
 * Version:   1.04
 * License:   GNU GPL
 * Author:    cagrET (Cezary Tomczak)
 * Homepage:  http://www.gosu.pl/mgc/
 * E-mail:    cagret at gmail.com
 * ------------------------------------------------------------
 */

class clanwars
{
 var $db,$prefix,$smarty;  //db class, prefix in tables, smarty class
 var $tpl_dir;  //templates directory
 var $show,$show_short;  //how many clanwars per page on list page, how many in short

 function init()
 {
   switch(get_param('action'))
   {
     case 'player':  $this->player();         break;
     case 'stats':   $this->stats();          break;
     case 'cwinfo':  $this->clanwars_info();  break;
     default:        $this->clanwars_list();  break;
   }

 } //end func
 

 function player()
 {
   $pid = (int) get_param('pid');
   
   $player   = array();
   $games1v1 = array();
   $games2v2 = array();
   $games3v3 = array();
   $games4v4 = array();
   
   #-- select player info
   $this->db->query("select * from ".$this->prefix."clanwars_players where pid='$pid'");
   if($this->db->num_rows() == 1)
   {
     $this->db->next_record();
     $player = $this->db->Record;
   }
   
   #-- select all players games (games1v1 games2v2 games3v3 games4v4 pid1 pid2 pid3 pid4)
   for($x=1; $x<=4; $x++)
   {
     $this->db->query("select t1.*,t2.cwid,t2.enemy,t2.time from ".$this->prefix."clanwars_games as t1 left join ".$this->prefix."clanwars as t2 on t1.cwid=t2.cwid where t1.pid{$x}='$pid' order by t1.gid desc");
     while($this->db->next_record()) ${'games'.$this->db->Record['type']}[] = $this->db->Record;
   }
   
   $this->smarty->assign('player', $player);
   $this->smarty->assign_by_ref('games1v1', $games1v1);
   $this->smarty->assign_by_ref('games2v2', $games2v2);
   $this->smarty->assign_by_ref('games3v3', $games3v3);
   $this->smarty->assign_by_ref('games4v4', $games4v4);
   
   $this->smarty->display($this->tpl_dir.'player.tpl');
   
 } //end func

 
 function stats()
 {
   $this->stats_game();
 } //end func
 

 function stats_game()
 {
   $players   = array();
   $explayers = array();

   $this->db->query("select * from ".$this->prefix."clanwars_players order by games desc,nick");
   while($this->db->next_record())
   {
     switch($this->db->Record['status'])
     {
       case '1':  $players[]   = $this->db->Record;  break;
       case '0':  $explayers[] = $this->db->Record;  break;
     }
   }

   #-- assigning vars and display
   $this->smarty->assign_by_ref('players', $players);
   $this->smarty->assign_by_ref('explayers', $explayers);
   
   $this->smarty->display($this->tpl_dir.'stats_game.tpl');

 } //end func
 
 
 function clanwars_info()
 {
   $cwid = (int) get_param('cwid');
   
   $clanwar  = array();
   $games1v1 = array();
   $games2v2 = array();
   $games3v3 = array();
   $games4v4 = array();
   
   #-- select clanwar info
   $this->db->query("select * from ".$this->prefix."clanwars where cwid='$cwid'");
   if($this->db->num_rows() == 1) {
     $this->db->next_record();
     $clanwar = $this->db->Record;
   }
   
   #-- select all players games (games1v1 games2v2 games3v3 games4v4 pid1 pid2 pid3 pid4)
   $this->db->query("select * from ".$this->prefix."clanwars_games where cwid='$cwid'");
   while($this->db->next_record())
   {
     switch($this->db->Record['type'])
     {
       case '1v1':  $games1v1[] = $this->db->Record;  break;
       case '2v2':  $games2v2[] = $this->db->Record;  break;
       case '3v3':  $games3v3[] = $this->db->Record;  break;
       case '4v4':  $games4v4[] = $this->db->Record;  break;
     }
   }
   
   #-- assigning vars and display
   $this->smarty->assign_by_ref('clanwar', $clanwar);
   $this->smarty->assign_by_ref('games1v1', $games1v1);
   $this->smarty->assign_by_ref('games2v2', $games2v2);
   $this->smarty->assign_by_ref('games3v3', $games3v3);
   $this->smarty->assign_by_ref('games4v4', $games4v4);
   
   $this->smarty->display($this->tpl_dir.'clanwars_info.tpl');
   
 } //end func


 function clanwars_list()
 // list of all clanwars
 {
   $page = (int) get_param('page');

   $clanwars = array();
   
   #-- counting pages
   $query = "select COUNT(*) as count from ".$this->prefix."clanwars";
   $this->db->query($query);
   $this->db->next_record();
   $pages = ceil($this->db->Record['count'] / $this->show);
   if($page <= 0) $page = 1;
   if($pages && $page > $pages) $page = $pages;

   #-- query
   $start = $page * $this->show - $this->show;
   $query  = "select * from ".$this->prefix."clanwars";
   $query .= " order by time desc limit $start,{$this->show}";
   $this->db->query($query);
   while($this->db->next_record()) {
     $clanwars[] = $this->db->Record;
   }
   
   #-- assigning vars and displaying
   $this->smarty->assign('page', $page);
   $this->smarty->assign('pages', $pages);
   $this->smarty->assign_by_ref('clanwars', $clanwars);

   $this->smarty->display($this->tpl_dir.'clanwars_list.tpl');
   
 } //end func
 

 function clanwars_short()
 // last 10 clanwars - news page
 {
   $tbl_clanwars = array();
   
   $this->db->query("select * from ".$this->prefix."clanwars order by time desc limit {$this->show_short}");
   while($this->db->next_record()) {
     $tbl_clanwars[] = $this->db->Record;
   }

   return $tbl_clanwars;
   
 } //end func

}

?>
