<?php
# ftp.inc.php

class ftp
{
 var $smarty;
 var $dir;
 var $size;
 var $ext_na;
 
 var $file;  //file name
 
 function ftp($smarty,$dir,$size,$ext_na)
 {
   include 'init/lib/files.lib.php';

   $this->smarty = &$smarty;
   $this->dir    = $dir;
   $this->size   = $size;
   $this->ext_na = $ext_na;
   
   $this->file = trim(urldecode(stripslashes(get_param('file'))));

   if(!$this->file_name_ok($this->file)) $this->file = '';

   $this->mod  = get_param('mod');
   
   switch($this->mod) {
     case 'edit':    $this->file_edit();    break;
     case 'delete':  $this->file_delete();  break;
     case 'add':     $this->file_add();     break;
     default:        $this->file_list();    break;
   }
   
 } //end func
 
 function file_list()
 {
   $dir = ReadDirectory($this->dir);
   natcasesort($dir);

   $list = array();
   $x = 1;
   foreach($dir as $key=>$value) {
	  if ('index.html' == $value) {
		continue;
	  }
     $list[$x]['file'] = $value;
     $list[$x]['size'] = natSize(filesize($this->dir . $value));
     $x++;
   }
   
   include 'templates/admin/ftp/list.tpl';
   
 } //end func

 function file_edit()
 {
   $submit = post_param('submit_file_edit');

   if($submit)
   {
     $name = trim(stripslashes(post_param('name')));
     $error = 0;

     # czy plik istnieje
     if(!is_file($this->dir . $this->file)) $error = 1;
     # czy plik o nazwie jaka chcemy nadac juz istnieje
     if(is_file($this->dir . $name) && $this->file != $name) $error = 1;

     if(!$error) {

       # czy nowa nazwa ok
       if(!$this->file_name_ok($name)) $error = 1;

       if(!$error) {

         # rename sometime does not work in a directory different than the script
         $oldWD = getcwd();
         chdir($this->dir);

         #zmieniamy nazwe
         if(!rename($this->file, $name)) $error = 1;
         
         # old Working Directory
         chdir($oldWD);

         if(!$error) $this->file_list();
       }
     }
     
     if($error) $submit = '';
   }

   if(!$submit)
   {
     $error = 0;
     
     # czy istnieje taki plik
     if(!is_file($this->dir . $this->file)) $error = 1;

     if(!$error) {
       include 'templates/admin/ftp/edit.tpl';
     }
     
     if($error) $this->file_list();
   }

 } //end func
 
 function file_delete()
 {
   # jesli taki plik istnieje kasuj
   if(is_file($this->dir . $this->file)) unlink($this->dir . $this->file);
   
   $this->file_list();
   
 } //end func
 
 function file_add()
 {
	 $submit = post_param('submit_file_add');

	if ($submit) {
		$name = post_param('name');
		 if ($name && !strstr($name, '.')) {
			$ext = pathinfo($_FILES['file']['name'], PATHINFO_EXTENSION); 
			if ($ext) {
				$name .= '.'.$ext;
			}
		 }
		 if (!$name) {
			$name = $_FILES['file']['name'];
		 }
	   $name = trim(stripslashes($name));
	}	 
	 
   $error = 0;

   if($submit)
   {
     # czy nazwa pliku ok
     if(!$this->file_name_ok($name)) $error = 1;

     if(!$error) {
       # czy nie ma juz takiego pliku
       if(is_file($this->dir . $name)) $error = 1;
     }
   
     if(!$error) {
       # czy jest uploadowany
       if(!is_uploaded_file($_FILES['file']['tmp_name'])) $error = 1;
     }
   
     if(!$error) {
       # czy wielkosc ok
       if($_FILES['file']['size'] > $this->size) $error = 1;
     }
   
     if(!$error) {
       # czy uploadowany bez bledow
       if(isset($_FILES['photo']['error']))
       {
         if($_FILES['photo']['error'] != 0) $error = 1;
       }
     }
   
     if(!$error) {
       # kopiujemy plik
       $url = $this->dir . $name;

       move_uploaded_file($_FILES['file']['tmp_name'], $url);
       chmod($url, 0644);
       
       $this->file_list();
     }
   
     if($error) $submit = '';
   }
   
   if(!$submit)
   {
     include 'templates/admin/ftp/add.tpl';
   }

 } //end func
 
 function file_name_ok($file)
 {
   $file = trim($file);
 
   if($file == '') return 0;

   if(preg_match('#/#', $file))    return 0;
   if(preg_match('#\\\#', $file))  return 0;

   foreach($this->ext_na as $key=>$value) {
     $len = strlen($value);
     if( $value == substr($file, -$len) ) return 0;
   }

   return 1;

 } //end func
 
}

?>
