<?php
/*
 * etphp/admin_classes/_members.class.php
 * ------------------------------------------------------------
 * Type:      PHP/MySQL
 * Name:      MyGosuClan
 * Version:   1.04
 * License:   GNU GPL
 * Author:    cagrET (Cezary Tomczak)
 * Homepage:  http://www.gosu.pl/mgc/
 * E-mail:    cagret at gmail.com
 * ------------------------------------------------------------
 */

class _members {
 var $db;
 var $smarty;
 
 var $mod;
 var $mid;
 
 var $tbl_members = array();
 var $tbl_users   = array();
 
 var $tbl_leaders    = array();
 var $tbl_active     = array();
 var $tbl_inactive   = array();

 var $error = array();

 function _members($db, $smarty)
 {
   include 'init/lib/html.lib.php';

   $this->db = &$db;
   $this->smarty = &$smarty;
   
   $this->mod = get_param('mod');
   $this->mid = (int) get_param('mid');
   
   #-- mod
   if($this->mod == 'delete' && $this->mid)   $this->mod_delete();
   elseif($this->mod == 'edit' && post_param('submit_members_edit') && $this->mid) $this->mod_edit();
   elseif($this->mod == 'add' && post_param('submit_members_add')) $this->mod_add();
   
   #-- get
   if($this->mod == 'edit') { $this->get_edit(); $this->get_users(); }
   elseif($this->mod == 'add') $this->get_users();
   elseif(!$this->mod) $this->get_list();

   #-- var
   $this->smarty->assign_by_ref('tbl_members', $this->tbl_members);
   $this->smarty->assign_by_ref('tbl_users', $this->tbl_users);
   $this->smarty->assign_by_ref('error', $this->error);
   
   $this->smarty->assign_by_ref('tbl_leaders', $this->tbl_leaders);
   $this->smarty->assign_by_ref('tbl_active', $this->tbl_active);
   $this->smarty->assign_by_ref('tbl_inactive', $this->tbl_inactive);

   #-- display
   if($this->mod == 'edit') $this->smarty->display('admin/_members/edit.tpl');
   elseif($this->mod == 'add') $this->smarty->display('admin/_members/add.tpl');
   elseif(!$this->mod) $this->smarty->display('admin/_members/list.tpl');
   
 } //end func
 
 function get_edit()
 {
   $this->db->query("select * from ".prefix."members where mid='{$this->mid}'");
   $this->db->next_record();
   $this->tbl_members = $this->db->Record;
 } //end func
 
 function mod_edit()
 {
   $post_uid      = (int) post_param('uid');
   $post_nick     = check_html(post_param('nick'));
   $post_mstatus   = (int) post_param('mstatus');

   #-- if any errors
   if(!$post_nick) $this->error['nick'] = 1;
   
   #-- if double
   $this->db->query("select * from ".prefix."members where mid<>'{$this->mid}' and ((uid='$post_uid' and uid<>'0') or nick='$post_nick')");
   if($this->db->num_rows() != 0) $this->error['member_exists'] = 1;
   
   if($this->error) return 0;
   
   $this->db->query("update ".prefix."members set uid='$post_uid', nick='$post_nick', mstatus='$post_mstatus' WHERE mid='{$this->mid}'");

   $this->mod = '';
 } //end func
 
 function mod_delete()
 {
   $this->db->query("delete from ".prefix."members where mid='{$this->mid}'");
   $this->mod = '';
 } //end func
 
 function mod_add()
 {
   $post_uid    = (int) post_param('uid');
   $post_nick   = check_html(post_param('nick'));
   $post_mstatus = (int) post_param('mstatus');

   #-- if any errors
   if(!$post_nick) $this->error['nick'] = 1;

   #-- if double
   $this->db->query("select * from ".prefix."members where (uid='$post_uid' and uid<>'0') or nick='$post_nick'");
   if($this->db->num_rows() != 0) $this->error['member_exists'] = 1;
   
   if($this->error) return 0;

   $this->db->query("insert into ".prefix."members set uid='$post_uid', nick='$post_nick', mstatus='$post_mstatus'");

   $this->mod = '';
 } //end func
 
 function get_users()
 {
   $this->db->query("select uid,user from ".prefix."users where auth>={$GLOBALS['auth']['member']} order by user");
   while($this->db->next_record()) {
     $this->tbl_users[$this->db->Record['uid']] = $this->db->Record['user'];
   }
 } //end func
 
 function get_list()
 {
   $this->db->query("SELECT mid,uid,nick,mstatus FROM ".prefix."members ORDER BY nick ASC");
   while($this->db->next_record())
   {
     if($this->db->Record['mstatus'] == 2) $this->tbl_leaders[] = $this->db->Record;
     elseif($this->db->Record['mstatus'] == 1) $this->tbl_active[] = $this->db->Record;
     elseif($this->db->Record['mstatus'] == 0) $this->tbl_inactive[] = $this->db->Record;
   }
 } //end func
 
} //end class
?>
