<?php
/*
 * modules/news/inc.News.php
 * ------------------------------------------------------------
 * Type:      PHP/MySQL
 * Name:      MyGosuClan
 * Version:   1.04
 * License:   GNU GPL
 * Author:    cagrET (Cezary Tomczak)
 * Homepage:  http://www.gosu.pl/mgc/
 * E-mail:    cagret at gmail.com
 * ------------------------------------------------------------
 */

class news {
 var $db; //reference to mysql class resource
 var $smarty;  //reference to smarty class resource
 var $show;  //shows x news
 
 var $tbl_news = array();     //news table from database
 var $tbl_comments = array(); //comments table from database
 var $tbl_edit = array();  //edit comment
 
 var $tbl_showall = array(); //show all news
 
 var $nid;  //news id
 var $pid;  //post id
 
 var $error = array();  //error

 function news($db, $smarty, $show)
 {
   include 'init/lib/time.lib.php';
   include 'init/lib/html.lib.php';
   include 'init/lib/files.lib.php';

   #-- initial variables
   $this->db = &$db;
   $this->smarty = &$smarty;
   $this->show = (int) $show;

   $this->nid = (int) get_param('nid');
   $this->pid = (int) get_param('pid');
   $mod = get_param('mod');
   
   #-- add_comment
   if(post_param('submit_add_comment')) $this->add_comment();
   if(post_param('submit_edit_comment')) $this->edit_comment();
   
   #-- query database
   if($this->pid && $mod == 'edit') $this->get_edit_comment();
   elseif($mod == 'showall') $this->showall();
   else
   {
     $this->get_news();
     if($this->nid) $this->get_comments();
   }
   
   #-- smarty variables
   $this->smarty->assign_by_ref('nid', $this->nid);
   $this->smarty->assign_by_ref('pid', $this->pid);

   $this->smarty->assign_by_ref('tbl_news', $this->tbl_news);
   $this->smarty->assign_by_ref('tbl_comments', $this->tbl_comments);
   $this->smarty->assign_by_ref('tbl_edit', $this->tbl_edit);
   
   $this->smarty->assign_by_ref('tbl_showall', $this->tbl_showall);
   
   #-- display
   if($this->pid && $mod == 'edit') $this->smarty->display('news/edit_comment.tpl');
   elseif($mod == 'showall') $this->smarty->display('news/showall.tpl');
   elseif($this->nid) $this->smarty->display('news/comments.tpl');
   else $this->smarty->display('news/news.tpl');
   
 } //end func
 
 function showall()
 {
   $show = $GLOBALS['cfg']['newsarchive'];
   $page = (int) get_param('page');
   
   #-- counting pages
   $this->db->query("select COUNT(*) from ".prefix."news");
   $this->db->next_record();
   $pages = ceil($this->db->Record['COUNT(*)'] / $show);

   if ($page < 1) $page = 1;
   if ($pages && $page > $pages) $page = $pages;
   $start = $page * $show - $show;
   $this->smarty->assign('page', $page);

   #-- 'next page' & 'previous page'
   $next = 0; $prev = 0;
   if($page >= 1 && $page < $pages) $next = $page + 1;
   if($page > 1 && $page <= $pages) $prev = $page - 1;

   #-- smarty variables
   $this->smarty->assign('next', $next);
   $this->smarty->assign('prev', $prev);
   $this->smarty->assign('pages', $pages);

   $this->db->query("select nid,title,date,posts,user,uid from ".prefix."news order by nid desc limit $start,$show");

   $tmp = '';
   while($this->db->next_record()) {
     $date = substr($this->db->Record['date'],5 ,5);
     if($tmp != $date) {
       $tmp = $date;
       $this->db->Record['date2'] = date("l, F jS", strtotime($this->db->Record['date']));
     }
     $this->db->Record['date'] = $date;
     $this->tbl_showall[] = $this->db->Record;
   }
   
 } //end func
 
 function get_news()
 {
   $page = (int) get_param('page');

   if($this->nid)
   {
     $this->db->query("select * from ".prefix."news where nid='{$this->nid}'");
     #-- if news exists
     if($this->db->num_rows() != 1) $this->nid = 0;
   }
   else
   {
     #-- counting pages
     $this->db->query("select COUNT(*) from ".prefix."news");
     $this->db->next_record();
     $pages = ceil($this->db->Record['COUNT(*)'] / $this->show);
     
     if ($page < 1) $page = 1;
     if ($pages && $page > $pages) $page = $pages;
     $start = $page * $this->show - $this->show;
     
     #-- 'next page' & 'previous page'
     $next = 0; $prev = 0;
     if($page >= 1 && $page < $pages) $next = $page + 1;
     if($page > 1 && $page <= $pages) $prev = $page - 1;
     
     #-- smarty variables
     $this->smarty->assign('page', $page);
     $this->smarty->assign('next', $next);
     $this->smarty->assign('prev', $prev);
     $this->smarty->assign('pages', $pages);

     $this->db->query("select * from ".prefix."news order by nid desc limit $start,{$this->show }");
   }

   while($this->db->next_record()) {
     $this->tbl_news[] = $this->db->Record;
   }
 } //end func
 
 function get_comments()
 {
   $this->db->query("select * from ".prefix."news_posts where nid='{$this->nid}' order by pid");
   while($this->db->next_record()) $this->tbl_comments[] = $this->db->Record;
 } //end func
 
 function get_edit_comment()
 {
   if(! $GLOBALS['access']['posts_edit'] ) return 0;
   
   $this->db->query("select * from ".prefix."news_posts where pid='{$this->pid}'");
   $this->db->next_record();
   $this->tbl_edit = $this->db->Record;
   $this->tbl_edit['ip_name'] = @gethostbyaddr($this->tbl_edit['ip']);
   $this->tbl_edit['text'] = check_undo($this->tbl_edit['text']);
   $this->tbl_edit['text'] = undo_edit_post($this->tbl_edit['text']);
 } //end func
 
 function add_comment()
 {
   if(! ($_SESSION['mgc']['auth'] >= $GLOBALS['auth']['normal']) ) return 0;

   $date = TimeToDate(time());
   $ip = get_ip();
   
   if(strlen(post_param('text')) > $GLOBALS['cfg']['max_comment_length']) {return 0;}
   
   #-- post vars
   if($_SESSION['mgc']['auth'] >= $GLOBALS['auth']['admin']) $post_text = check_nosafe(post_param('text'));
   else $post_text = check_safe(post_param('text'));
   
   $_POST['text'] = '';
   
   #-- if form fields arent empty
   if(!$post_text) $this->error[] = 'text';
   
   #-- if news not exists
   if(!$this->news_exists()) return 0;
   
   #-- last post of that user
   $this->db->query("select MAX(pid) from ".prefix."news_posts where uid='{$_SESSION['mgc']['uid']}'");
   $this->db->next_record();
   $max = $this->db->Record['MAX(pid)'];
   
   #-- if last comment is the same - double post
   $this->db->query("select * from ".prefix."news_posts where pid='$max' and text='$post_text'");
   if($this->db->num_rows() != 0) return 0;
   
   if($this->error) return 0;

   #-- adding comment
   $this->db->query("insert into ".prefix."news_posts set nid='{$this->nid}', uid='{$_SESSION['mgc']['uid']}', user='{$_SESSION['mgc']['user']}', date='$date', text='$post_text', ip='$ip'");
   
   #-- update news: `posts`
   if($this->db->Query_ID) {
     $this->db->query("update ".prefix."news set posts=posts+1 where nid='{$this->nid}'");
   }
 } //end func
 
 function edit_comment()
 {
   if(! $GLOBALS['access']['posts_edit'] ) return 0;
   
   $text = check_nosafe(post_param('text'));
   $text = $text . edit_post($_SESSION['mgc']['user'], TimeToDate(time()));
   
   $this->db->query("update ".prefix."news_posts set text='$text' where pid='{$this->pid}'");
   
   $_POST['text'] = '';
   
 } //end func
 
 function news_exists()
 {
   $this->db->query("select * from ".prefix."news where nid='{$this->nid}'");
   if($this->db->num_rows() != 1) return 0;
   return 1;
 } //end func
}

?>
